# CCats - Covert Channels are Tricky Stuff

CCats is a covert channel tool which works as man in the middle.
Our motivation is to create a tool which allows you to send files over a covert channel between two controlled servers.

This repository consists of three programs: a server (daemon), a CLI-client and a GUI-client.

The server manages the uploaded files and transmits the files over the covert channel.
The clients let you connect and login to the server and upload files and start file transmission over the covert channel.

## The basic setup
```
   A           -----------------                        ------------------           B
   o  traffic  |               |                        |                |  traffic  o
  /|\ ---------| active Server | <== covert channel ==> | passive Server |--------- /|\
   \\          |               |                        |                |          //
               -----------------                        ------------------
                      ||                                       ||
               client connection                        client connection
                      ||                                       ||
               E  ----------                               ----------  F
               o  |        |                               |        |  o
              /|\ | Client |                               | Client | /|\
               \\ |        |                               |        | //
                  ----------                               ----------
```
E wants to send a file to F. A and E live together and B and F live together. E and F know that A will surf on B's website a lot so they decided to setup a covert channel which utilises the traffic of A and B as man in the middle.
A surfs on the website of B on Port p and produces traffic between them. E and F set up the two servers. The active server is the server which will be used to send a file to the passive server.
E sets the target IP on the active server side to the IP of A and F the target IP on the passive side to the IP of B. The target Port on both sides is set to p.
Now the servers are forwarding A's and B's traffic and can add secret data to the traffic.
E connects to the active server with his/her client and queues a file for sending over the covert channel. The file transmission will start once A surfs on B's website again. Now E and F have to wait until A produced enough traffic to transmit the file completely.
After the file transmission finished F can downlod the file with his/her client.

## Encryption
E and F can decide to use a common key for symmetrical encryption. Files will be encrypted on the client side so the servers cannot read the files as plain data. The covert channel does not add another encryption-layer so it's encouraged to use this feature.
